/*****************************************************************************
 * Chart Screen driver
 *****************************************************************************
 * FileName:        Screen_Chart.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Screen_Chart.h"

/********************************************************************/
void Show_Screen_Chart()
{
  ActScrID = SCREEN_CHART;
  
  // Load Form
  GuiCmd_Load_Form(ActScrID);

  // Initialize objets
  CH_Enable[0] = 0;
  CH_Enable[1] = 0;
  CH_Enable[2] = 0;
  CH_Enable[3] = 0;

  CH_Average[0] = 0;
  CH_Average[1] = 0;
  CH_Average[2] = 0;
  CH_Average[3] = 0;

  CH_Invert[0] = 0;
  CH_Invert[1] = 0;
  CH_Invert[2] = 0;
  CH_Invert[3] = 0;

  CH_Couple[0] = 0;
  CH_Couple[1] = 0;
  CH_Couple[2] = 0;
  CH_Couple[3] = 0;

  ChartUpdateEnable = 0;
  ChartUpdateFlag = 0;
  ChartUpdateTime = 5;
  ChartTimeIndex = 0;
  ChartTimer = 0;
  CHIndex = 0;

  // Show Screen
  GuiCmd_Draw_Form(ActScrID);

  // Set first time select LED to ON
  GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED4, 1);

}

/*******************************************************************/
void ui_Screen_Chart()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_CHART_BUTTON_EXIT:
      CH_Enable[0] = 0;
      CH_Enable[1] = 0;
      CH_Enable[2] = 0;
      CH_Enable[3] = 0;
      ChartUpdateEnable = 0;
      Show_Screen_Main();
      break;

      case SCREEN_CHART_BUTTON_TIMESELECT:
      ChartTimeIndex++;
      if (ChartTimeIndex > 3)
       {
         ChartTimeIndex = 0;
       }
      ChartUpdateTime = 5*ChartTimeIndex + 5;
      ChartTimer = 0;
      switch (ChartTimeIndex)
       {
         case 0:
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED4, 1);
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED1, 0);
         break;

         case 1:
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED4, 0);
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED3, 1);
         break;

         case 2:
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED3, 0);
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED2, 1);
         break;

         case 3:
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED2, 0);
         GuiCmd_Image_Value(SCREEN_CHART_IMAGE_LED1, 1);
         break;
        }
      break;

      case SCREEN_CHART_BUTTON_CH1:
      GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHSELECT, (char*)"CH1");
      CHIndex = 0;
      Update_CH_Settings();
      break;

      case SCREEN_CHART_BUTTON_CH2:
      GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHSELECT, (char*)"CH2");
      CHIndex = 1;
      Update_CH_Settings();
      break;

      case SCREEN_CHART_BUTTON_CH3:
      GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHSELECT, (char*)"CH3");
      CHIndex = 2;
      Update_CH_Settings();
      break;

      case SCREEN_CHART_BUTTON_CH4:
      GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHSELECT, (char*)"CH4");
      CHIndex = 3;
      Update_CH_Settings();
      break;

      case SCREEN_CHART_BUTTON_F1:
      if (CH_Enable[CHIndex] == 0)
       {
        CH_Enable[CHIndex] = 1;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHENABLE, (char*)"ON");
       }
      else
       {
        CH_Enable[CHIndex] = 0;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHENABLE, (char*)"OFF");
       }
      break;

      case SCREEN_CHART_BUTTON_F2:
      if (CH_Couple[CHIndex] == 0)
       {
        CH_Couple[CHIndex] = 1;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHCOUPLING, (char*)"AC");
       }
      else
       {
        CH_Couple[CHIndex] = 0;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHCOUPLING, (char*)"DC");
       }
      break;

      case SCREEN_CHART_BUTTON_F3:
      if (CH_Invert[CHIndex] == 0)
       {
        CH_Invert[CHIndex] = 1;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHINVERT, (char*)"Inv");
       }
      else
       {
        CH_Invert[CHIndex] = 0;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHINVERT, (char*)"Nor");
       }
      break;

     case SCREEN_CHART_BUTTON_F4:
      if (CH_Average[CHIndex] == 0)
       {
        CH_Average[CHIndex] = 1;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHAVERAGE, (char*)"1");
       }
      else
       {
        CH_Average[CHIndex] = 0;
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHAVERAGE, (char*)"32");
       }
      break; 
   }
  ChartUpdateEnable = CH_Enable[0] | CH_Enable[1] | CH_Enable[2] | CH_Enable[3];
  }
}

/*****************************************************************************************/
void Update_CH_Settings()
{
     if (CH_Enable[CHIndex] == 0)
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHENABLE, (char*)"OFF");
       }
      else
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHENABLE, (char*)"ON");
       }

      if (CH_Couple[CHIndex] == 0)
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHCOUPLING, (char*)"DC");
       }
      else
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHCOUPLING, (char*)"AC");
       }

      if (CH_Invert[CHIndex] == 0)
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHINVERT, (char*)"Nor");
       }
      else
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHINVERT, (char*)"Inv");
       }

      if (CH_Average[CHIndex] == 0)
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHAVERAGE, (char*)"32");
       }
      else
       {
        GuiCmd_TextBox_Text(SCREEN_CHART_TEXTBOX_CHAVERAGE, (char*)"1");
       }
} 

     


