/*****************************************************************************
 * Control Screen driver
 *****************************************************************************
 * FileName:        Screen_Control.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"
#include "PWM.h"
#include "LED.h"


#include "Screen_Control.h"


/********************************************************************/
void Show_Screen_Control()
{
  ActScrID = SCREEN_CONTROL;
  
  // Load Form
  GuiCmd_Load_Form(ActScrID);

  // Initialize objets
  ControlUpdateTime = 250;
  ControlUpdateFlag = 0;
  ControlUpdateEnable = 0;
  ControlTimer = 0;
  SetRedPWM(0);
  SetBluePWM(0);
  SetGreenPWM(0);
  LED2OFF();
  LED3OFF();
  LED4OFF();

  // Show Screen
  GuiCmd_Draw_Form(ActScrID);
}

/*******************************************************************/
void ui_Screen_Control()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_CONTROL_BUTTON_EXIT:
      ControlUpdateEnable = 0;
      Show_Screen_Main();
      break;

      case SCREEN_CONTROL_BUTTON_WATERPUMPSTART:
      GuiCmd_Button_State(SCREEN_CONTROL_BUTTON_WATERPUMPSTOP, 0);
      GuiCmd_Button_State(SCREEN_CONTROL_BUTTON_WATERPUMPSTART, 2);
      ControlTimer = 0;
      ControlUpdateEnable = 1;
      break;

      case SCREEN_CONTROL_BUTTON_WATERPUMPSTOP:
      GuiCmd_Button_State(SCREEN_CONTROL_BUTTON_WATERPUMPSTART, 0);
      GuiCmd_Button_State(SCREEN_CONTROL_BUTTON_WATERPUMPSTOP, 2);
      ControlTimer = 0;
      ControlUpdateEnable = 0;
      break;  
   }
  }

 if (UI_Msg.Code == IMAGE_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_CONTROL_IMAGE_LED1:
      if(UI_Msg.Value == 1)
       {
         LED2ON();
       }
      else
       {
         LED2OFF();
       }
      break;
     
      case SCREEN_CONTROL_IMAGE_LED2:
      if(UI_Msg.Value == 1)
       {
         LED3ON();
       }
      else
       {
         LED3OFF();
       }
      break;

      case SCREEN_CONTROL_IMAGE_LED3:
      if(UI_Msg.Value == 1)
       {
         LED4ON();
       }
      else
       {
         LED4OFF();
       }
      break; 
   }
  }

  if (UI_Msg.Code == SLIDER_CODE)
  {
    switch (UI_Msg.ID)
     {
       case SCREEN_CONTROL_SLIDER_RED:
       SetGreenPWM (3*UI_Msg.Value);
       break;

       case SCREEN_CONTROL_SLIDER_GREEN:
       SetRedPWM(3*UI_Msg.Value);
       break;

       case SCREEN_CONTROL_SLIDER_BLUE:
       SetBluePWM(3*UI_Msg.Value);
       break;
     }
   } 
} 

     


