/*****************************************************************************
 * Dashboard Screen driver
 *****************************************************************************
 * FileName:        Screen_Dashboard.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Screen_DashBoard.h"


/********************************************************************/
void Show_Screen_DashBoard()
{
  ActScrID = SCREEN_DASHBOARD;
  
  // Load Form
  GuiCmd_Load_Form(ActScrID);

  // Initialize
  DashBoardUpdateTime = 250;
  DashBoardUpdateFlag = 0;
  DashBoardUpdateEnable = 0;
  DashBoardTimer = 0;

  // Show Screen
  GuiCmd_Draw_Form(ActScrID);

  // Enable DashBoard Update
  DashBoardUpdateEnable = 1;
}

/*******************************************************************/
void ui_Screen_DashBoard()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_DASHBOARD_BUTTON_EXIT:
      DashBoardUpdateEnable = 0;
      Show_Screen_Main();
      break;
   }
  }
} 


     


