/*****************************************************************************
 * Main Screen driver
 *****************************************************************************
 * FileName:        Screen_Main.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"


/********************************************************************/
void Show_Screen_Main()
{
  ActScrID = SCREEN_MAIN;
  
  // Load Form
  GuiCmd_Load_Form(ActScrID);

  // Show Screen
  GuiCmd_Draw_Form(ActScrID);
}

/********************************************************************/
void ui_Screen_Main()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_MAIN_BUTTON_TIME:
      Show_Screen_Time();
      break;

      case SCREEN_MAIN_BUTTON_DASHBOARD:
      Show_Screen_DashBoard();
      break;

      case SCREEN_MAIN_BUTTON_DRAWPAD:
      Show_Screen_DrawPad();
      break;

      case SCREEN_MAIN_BUTTON_CONTROL:
      Show_Screen_Control();
      break;

      case SCREEN_MAIN_BUTTON_PHONE:
      Show_Screen_Phone();
      break;

      case SCREEN_MAIN_BUTTON_KEYBOARD:
      Show_Screen_KeyBoard();
      break;

      case SCREEN_MAIN_BUTTON_CHART:
      Show_Screen_Chart();
      break;

      case SCREEN_MAIN_BUTTON_THERMOSTATE:
      Show_Screen_Thermostate();
      break;

      case SCREEN_MAIN_BUTTON_TOOLS:
      Show_Screen_Tools();
      break;
   }
  }
} 

     


