/*****************************************************************************
 * Phone Screen driver
 *****************************************************************************
 * FileName:        Screen_Phone.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Screen_Phone.h"
#include "Win1_FontBox.h"


/********************************************************************/
void Show_Screen_Phone()
{
  ActScrID = SCREEN_PHONE;
  
  // Load Form
  GuiCmd_Load_Form(ActScrID);

  Phone_CharCount = 0;
  Phone_CurX = 0;
  Phone_CurY = 0;

  // Get Font4 Height
  TerCmd_Get_FontHeight(4);
  // Get Font4 Characters widths
  TerCmd_Get_FontWidth(4, CharWidth);
  // Set To Font4
  GuiCmd_Set_ObjProperty_Byte(PICTUREBOX_CODE, SCREEN_PHONE_PICTUREBOX_DISPLAY, PICTUREBOX_PRO_FONT,0 , 4);
  // Update PictureBox Draw Color
  GuiCmd_Set_ObjProperty_Word(PICTUREBOX_CODE, SCREEN_PHONE_PICTUREBOX_DISPLAY, PICTUREBOX_PRO_FORECOLOR, REDRAW_NO, BROWN);

  // Show Screen
  GuiCmd_Draw_Form(ActScrID);
}

/*******************************************************************/
void ui_Screen_Phone()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case SCREEN_PHONE_BUTTON_EXIT:
      Show_Screen_Main();
      break;

      case SCREEN_PHONE_BUTTON_FLASHEXIT:
      GuiCmd_PictureBox_Clear(SCREEN_PHONE_PICTUREBOX_DISPLAY);
      Phone_CharCount = 0;
      Phone_CurX = 0;
      Phone_CurY = 0;
      break;

      case SCREEN_PHONE_BUTTON_DIAL0:
      Phone_Char = '0';
      Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
        Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
        Phone_Text[Phone_CharCount] = Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL1:
      Phone_Char = '1';
      Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

     case SCREEN_PHONE_BUTTON_DIAL2:
     Phone_Char = '2';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL3:
     Phone_Char = '3';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL4:
     Phone_Char = '4';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL5:
     Phone_Char = '5';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL6:
     Phone_Char = '6';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL7:
     Phone_Char = '7';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL8:
     Phone_Char = '8';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL9:
     Phone_Char = '9';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL_STAR:
     Phone_Char = '*';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;

      case SCREEN_PHONE_BUTTON_DIAL_POUND:
     Phone_Char = '#';
     Phone_CharCount++;
      if (Phone_CharCount < PHONE_MAXCHARCOUNT)
       {
        GuiCmd_PictureBox_PrintChar(SCREEN_PHONE_PICTUREBOX_DISPLAY,Phone_CurX,Phone_CurY,Phone_Char);
       Phone_CurX =Phone_CurX + CharWidth[Phone_Char - 32] + 1;
       Phone_Text[Phone_CharCount] =Phone_Char;
       }
      break;
   }
  }
} 

     


