/*****************************************************************************
 * Terminal Commands driver For SegeNT
 *****************************************************************************
 * FileName:        TerCommands.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Abdul Haidar         4/15/2014
 *****************************************************************************/
#include "TerCommands.h"
#include "RS232.h"

/****************************************************************************/
void TerCmd_Get_ProductNumber()
{
  BYTE i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_PRODUCTNUMBER;
  RXCount = GET_PRODUCTNUMBER_RXNOB + 3;
  TXCount = GET_PRODUCTNUMBER_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  
     // Get Product Number
     for (i=0; i<10; i++)
      {
       ProductNumber[i] = RXBuffer[i+2];
      }
     ProductNumber[11] = 0;  // Termination
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_FirmwareVersion()
{
  BYTE i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FIRMWAREVERSION;
  RXCount = GET_FIRMWAREVERSION_RXNOB + 3;
  TXCount = GET_FIRMWAREVERSION_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Firmware version Number
     for (i=0; i<5; i++)
      {
       FirmwareVersion[i] = RXBuffer[i+2];
      }
     FirmwareVersion[6] = 0;
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_SerialNumber()
{
  BYTE i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_SERIALNUMBER;
  RXCount = GET_SERIALNUMBER_RXNOB + 3;
  TXCount = GET_SERIALNUMBER_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Serial Number
     for (i=0; i<5; i++)
      {
       SerialNumber[i] = RXBuffer[i+2];
      }
     SerialNumber[7] = 0;
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_UserVersion()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_USERVERSION;
  RXCount = GET_USERVERSION_RXNOB + 3;
  TXCount = GET_USERVERSION_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get User Version
     UserVersion = (WORD)256*RXBuffer[2] + RXBuffer[3];
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_UserIDNumber0()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_USERIDNUMBER0;
  RXCount = GET_USERIDNUMBER0_RXNOB + 3;
  TXCount = GET_USERIDNUMBER0_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get UserIDNumber0
     UserIDNumber0 = (WORD)256*RXBuffer[2] + RXBuffer[3];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_UserIDNumber1()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_USERIDNUMBER1;
  RXCount = GET_USERIDNUMBER1_RXNOB + 3;
  TXCount = GET_USERIDNUMBER1_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get UserIDNumber1
     UserIDNumber1 = (WORD)256*RXBuffer[2] + RXBuffer[3];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_LCDSize()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_LCDSIZE;
  RXCount = GET_LCDSIZE_RXNOB + 3;
  TXCount = GET_LCDSIZE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get LCD Resolution
     LCDResX = (WORD)256*RXBuffer[2] + RXBuffer[3];
     LCDResY = (WORD)256*RXBuffer[4] + RXBuffer[5];
     
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TouchScreenType()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TOUCHSCREENTYPE;
  RXCount = GET_TOUCHSCREENTYPE_RXNOB + 3;
  TXCount = GET_TOUCHSCREENTYPE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Touch Screen Type
     TouchScreenType = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_FlashSize()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FLASHSIZE;
  RXCount = GET_FLASHSIZE_RXNOB + 3;
  TXCount = GET_FLASHSIZE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Sege Flash Memory Size
     FlashSize = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_UserFlashSize()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_USERFLASHSIZE;
  RXCount = GET_USERFLASHSIZE_RXNOB + 3;
  TXCount = GET_USERFLASHSIZE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get User Flash Memory Section Size
     UserFlashSize = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_SystemStatus()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_SYSTEMSTATUS;
  RXCount = GET_SYSTEMSTATUS_RXNOB + 3;
  TXCount = GET_SYSTEMSTATUS_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Sege Status Byte
     SegeStatus = RXBuffer[2];
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}


/****************************************************************************/
void TerCmd_Cal_TouchScreen()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = CAL_TOUCHSCREEN;
  RXCount = 1;
  TXCount = CAL_TOUCHSCREEN_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_Brightness(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_BRIGHTNESS;
  RXCount = 1;
  TXCount = SET_BRIGHTNESS_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_Backlight(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_BACKLIGHT;
  RXCount = 1;
  TXCount = SET_BACKLIGHT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_Beep(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_BEEP;
  RXCount = 1;
  TXCount = SET_BEEP_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_LCD(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_LCD;
  RXCount = 1;
  TXCount = SET_LCD_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
// Write 256bytes (1 page) to user flash memory
void TerCmd_Set_UserFlash(WORD Page, BYTE* pBuffer )
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_USERFLASH;
  RXCount = 1;
  TXCount = SET_USERFLASH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (Page>>8)&0x00FF;
  TXBuffer[5] = (Page)&0x00FF;

  for (i=0; i<256; i++)
   {
    TXBuffer[6 + i] = *pBuffer;
    pBuffer++;
   }

  TXBuffer[262] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
// Read one page from User Flash memory
void TerCmd_Get_UserFlash(WORD Page, BYTE* pBuffer )
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_USERFLASH;
  RXCount = GET_USERFLASH_RXNOB + 3;
  TXCount = GET_USERFLASH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (Page>>8)&0x00FF;
  TXBuffer[5] = (Page)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Save User flash page to pBuffer
     for (i=0; i<256; i++)
     {
      *pBuffer = RXBuffer[2 + i];
       pBuffer++;
     }
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
// Erase one sector (16 pages) from User Flash memory
void TerCmd_Erase_UserFlash(WORD Sector)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = ERASE_USERFLASH;
  RXCount = 1;
  TXCount = ERASE_USERFLASH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (Sector>>8)&0x00FF;
  TXBuffer[5] = (Sector)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_DigitalOutput(BYTE Addr, BYTE Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_DIGITALOUTPUT;
  RXCount = 1;
  TXCount = SET_DIGITALOUTPUT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Addr;
  TXBuffer[5] = Value;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_DigitalInput(BYTE Addr)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_DIGITALINPUT;
  RXCount = GET_DIGITALINPUT_RXNOB + 3;
  TXCount = GET_DIGITALINPUT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Addr;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Digital Input
     DigitalInput[Addr] = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_AnalogInput(BYTE Addr)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_ANALOGINPUT;
  RXCount = GET_ANALOGINPUT_RXNOB + 3;
  TXCount = GET_ANALOGINPUT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Addr;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Analog Input
     AnalogInput[Addr] = (WORD)256*RXBuffer[2] + RXBuffer[3];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_PWM(BYTE Addr, WORD Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_PWM;
  RXCount = 1;
  TXCount = SET_PWM_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Addr;
  TXBuffer[5] = (Value>>8)&0x00FF;
  TXBuffer[6] = (Value)&0x00FF;
  TXBuffer[7] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TouchData()
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TOUCHDATA;
  RXCount = GET_TOUCHDATA_RXNOB + 3;
  TXCount = GET_TOUCHDATA_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Touch Data
     TouchData.Status = RXBuffer[2];
     TouchData.X = (WORD)256*RXBuffer[3] + RXBuffer[4];
     TouchData.Y = (WORD)256*RXBuffer[5] + RXBuffer[6];
     TouchData.RFU = (WORD)256*RXBuffer[7] + RXBuffer[8];
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_ProductCode()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_PRODUCTCODE;
  RXCount = GET_PRODUCTCODE_RXNOB + 3;
  TXCount = GET_PRODUCTCODE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Product Code
     ProductCode = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Play_Audio(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = PLAY_AUDIO;
  RXCount = 1;
  TXCount = PLAY_AUDIO_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_EntVolume(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_ENTVOLUME;
  RXCount = 1;
  TXCount = SET_ENTVOLUME_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_ExtVolume(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_EXTVOLUME;
  RXCount = 1;
  TXCount = SET_EXTVOLUME_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Mute(BYTE Value)
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = MUTE;
  RXCount = 1;
  TXCount = MUTE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Clear_Screen()
{

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = CLEAR_SCREEN;
  RXCount = 1;
  TXCount = CLEAR_SCREEN_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_BackColor(WORD Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_BACKCOLOR;
  RXCount = 1;
  TXCount = SET_BACKCOLOR_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (Value>>8)&0x00FF;
  TXBuffer[5] = (Value)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_DrawColor(WORD Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_DRAWCOLOR;
  RXCount = 1;
  TXCount = SET_DRAWCOLOR_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (Value>>8)&0x00FF;
  TXBuffer[5] = (Value)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_DrawWidth(BYTE Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_DRAWWIDTH;
  RXCount = 1;
  TXCount = SET_DRAWWIDTH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_DrawType(BYTE Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_DRAWTYPE;
  RXCount = 1;
  TXCount = SET_DRAWTYPE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Line(WORD X1, WORD Y1, WORD X2, WORD Y2)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_LINE;
  RXCount = 1;
  TXCount = DRAW_LINE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X1>>8)&0x00FF;
  TXBuffer[5] = (X1)&0x00FF;
  TXBuffer[6] = (Y1>>8)&0x00FF;
  TXBuffer[7] = (Y1)&0x00FF;
  TXBuffer[8] = (X2>>8)&0x00FF;
  TXBuffer[9] = (X2)&0x00FF;
  TXBuffer[10] = (Y2>>8)&0x00FF;
  TXBuffer[11] = (Y2)&0x00FF;
  TXBuffer[12] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Rectangle(WORD X1, WORD Y1, WORD X2, WORD Y2)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_RECTANGLE;
  RXCount = 1;
  TXCount = DRAW_RECTANGLE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X1>>8)&0x00FF;
  TXBuffer[5] = (X1)&0x00FF;
  TXBuffer[6] = (Y1>>8)&0x00FF;
  TXBuffer[7] = (Y1)&0x00FF;
  TXBuffer[8] = (X2>>8)&0x00FF;
  TXBuffer[9] = (X2)&0x00FF;
  TXBuffer[10] = (Y2>>8)&0x00FF;
  TXBuffer[11] = (Y2)&0x00FF;
  TXBuffer[12] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_FilledRectangle(WORD X1, WORD Y1, WORD X2, WORD Y2)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_FILLEDRECTANGLE;
  RXCount = 1;
  TXCount = DRAW_FILLEDRECTANGLE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X1>>8)&0x00FF;
  TXBuffer[5] = (X1)&0x00FF;
  TXBuffer[6] = (Y1>>8)&0x00FF;
  TXBuffer[7] = (Y1)&0x00FF;
  TXBuffer[8] = (X2>>8)&0x00FF;
  TXBuffer[9] = (X2)&0x00FF;
  TXBuffer[10] = (Y2>>8)&0x00FF;
  TXBuffer[11] = (Y2)&0x00FF;
  TXBuffer[12] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Bevel(WORD X1, WORD Y1, WORD X2, WORD Y2, BYTE R)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_BEVEL;
  RXCount = 1;
  TXCount = DRAW_BEVEL_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X1>>8)&0x00FF;
  TXBuffer[5] = (X1)&0x00FF;
  TXBuffer[6] = (Y1>>8)&0x00FF;
  TXBuffer[7] = (Y1)&0x00FF;
  TXBuffer[8] = (X2>>8)&0x00FF;
  TXBuffer[9] = (X2)&0x00FF;
  TXBuffer[10] = (Y2>>8)&0x00FF;
  TXBuffer[11] = (Y2)&0x00FF;
  TXBuffer[12] = R;
  TXBuffer[13] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_FilledBevel(WORD X1, WORD Y1, WORD X2, WORD Y2, BYTE R)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_FILLEDBEVEL;
  RXCount = 1;
  TXCount = DRAW_FILLEDBEVEL_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X1>>8)&0x00FF;
  TXBuffer[5] = (X1)&0x00FF;
  TXBuffer[6] = (Y1>>8)&0x00FF;
  TXBuffer[7] = (Y1)&0x00FF;
  TXBuffer[8] = (X2>>8)&0x00FF;
  TXBuffer[9] = (X2)&0x00FF;
  TXBuffer[10] = (Y2>>8)&0x00FF;
  TXBuffer[11] = (Y2)&0x00FF;
  TXBuffer[12] = R;
  TXBuffer[13] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Circle(WORD X0, WORD Y0, WORD R1, WORD R2)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_CIRCLE;
  RXCount = 1;
  TXCount = DRAW_CIRCLE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X0>>8)&0x00FF;
  TXBuffer[5] = (X0)&0x00FF;
  TXBuffer[6] = (Y0>>8)&0x00FF;
  TXBuffer[7] = (Y0)&0x00FF;
  TXBuffer[8] = (R1>>8)&0x00FF;
  TXBuffer[9] = (R1)&0x00FF;
  TXBuffer[10] = (R2>>8)&0x00FF;
  TXBuffer[11] = (R2)&0x00FF;
  TXBuffer[12] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_FilledCircle(WORD X0, WORD Y0, WORD R1, WORD R2)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_FILLEDCIRCLE;
  RXCount = 1;
  TXCount = DRAW_FILLEDCIRCLE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X0>>8)&0x00FF;
  TXBuffer[5] = (X0)&0x00FF;
  TXBuffer[6] = (Y0>>8)&0x00FF;
  TXBuffer[7] = (Y0)&0x00FF;
  TXBuffer[8] = (R1>>8)&0x00FF;
  TXBuffer[9] = (R1)&0x00FF;
  TXBuffer[10] = (R2>>8)&0x00FF;
  TXBuffer[11] = (R2)&0x00FF;
  TXBuffer[12] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Pixel(WORD X, WORD Y)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_PIXEL;
  RXCount = 1;
  TXCount = DRAW_PIXEL_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X>>8)&0x00FF;
  TXBuffer[5] = (X)&0x00FF;
  TXBuffer[6] = (Y>>8)&0x00FF;
  TXBuffer[7] = (Y)&0x00FF;
  TXBuffer[8] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Copy_Area(WORD X, WORD Y, BYTE W, BYTE H)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = COPY_AREA;
  RXCount = 1;
  TXCount = COPY_AREA_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X>>8)&0x00FF;
  TXBuffer[5] = (X)&0x00FF;
  TXBuffer[6] = (Y>>8)&0x00FF;
  TXBuffer[7] = (Y)&0x00FF;
  TXBuffer[8] = W;
  TXBuffer[9] = H;
  TXBuffer[10] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Paste_Area(WORD X, WORD Y, BYTE W, BYTE H)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = PASTE_AREA;
  RXCount = 1;
  TXCount = PASTE_AREA_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X>>8)&0x00FF;
  TXBuffer[5] = (X)&0x00FF;
  TXBuffer[6] = (Y>>8)&0x00FF;
  TXBuffer[7] = (Y)&0x00FF;
  TXBuffer[8] = W;
  TXBuffer[9] = H;
  TXBuffer[10] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_Pixel(WORD X, WORD Y)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_PIXEL;
  RXCount = GET_PIXEL_RXNOB + 3;
  TXCount = GET_PIXEL_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X>>8)&0x00FF;
  TXBuffer[5] = (X)&0x00FF;
  TXBuffer[6] = (Y>>8)&0x00FF;
  TXBuffer[7] = (Y)&0x00FF;
  TXBuffer[8] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Pixel Color
     PixelColor = (WORD)256*RXBuffer[2] + RXBuffer[3];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_ActiveLayer(BYTE Value)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_ACTIVELAYER;
  RXCount = 1;
  TXCount = SET_ACTIVELAYER_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Value;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_ActiveLayer()
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_ACTIVELAYER;
  RXCount = GET_ACTIVELAYER_RXNOB + 3;
  TXCount = GET_ACTIVELAYER_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Active Layer
     ActiveLayer = RXBuffer[2];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
// Get the Copy Buffer. Each block is 128 pixels
void TerCmd_Get_CopyBuffer(BYTE Block, WORD* pBuffer)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_COPYBUFFER;
  RXCount = GET_COPYBUFFER_RXNOB + 3;
  TXCount = GET_COPYBUFFER_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = Block;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Save Sege Copy Buffer to pBuffer
     for (i=0; i<128; i+2)
     {
      *pBuffer = (WORD)256*RXBuffer[2 + i] + RXBuffer[3 + i];
       pBuffer+2;
     }
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Draw_Bitmap(WORD X, WORD Y, WORD W, WORD H, WORD Block, WORD* pBuffer)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = DRAW_BITMAP;
  RXCount = 1;
  TXCount = DRAW_BITMAP_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (X>>8)&0x00FF;
  TXBuffer[5] = (X)&0x00FF;
  TXBuffer[6] = (Y>>8)&0x00FF;
  TXBuffer[7] = (Y)&0x00FF;
  TXBuffer[8] = (W>>8)&0x00FF;
  TXBuffer[9] = (W)&0x00FF;
  TXBuffer[10] = (H>>8)&0x00FF;
  TXBuffer[11] = (H)&0x00FF;
  TXBuffer[12] = (Block>>8)&0x00FF;
  TXBuffer[13] = (Block)&0x00FF;

  for (i=0; i<128; i+2)
     {
       RXBuffer[14 + i] = (*pBuffer>>8)&0x00FF;
       RXBuffer[15 + i] = (*(pBuffer + 1))&0x00FF;
       pBuffer+2;
     }

  TXBuffer[270] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Show_Bitmap(WORD ID, WORD X, WORD Y, BYTE Ori, BYTE Mir)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SHOW_BITMAP;
  RXCount = 1;
  TXCount = SHOW_BITMAP_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (ID>>8)&0x00FF;
  TXBuffer[5] = (ID)&0x00FF;
  TXBuffer[6] = (X>>8)&0x00FF;
  TXBuffer[7] = (X)&0x00FF;
  TXBuffer[8] = (Y>>8)&0x00FF;
  TXBuffer[9] = (Y)&0x00FF;
  TXBuffer[10] = Ori;
  TXBuffer[11] = Mir;
  TXBuffer[10] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_BitmapDim(WORD ID)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_BITMAPDIM;
  RXCount = GET_BITMAPDIM_RXNOB + 3;
  TXCount = GET_BITMAPDIM_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (ID>>8)&0x00FF;
  TXBuffer[5] = (ID)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Bitmap width and height
     BitmapWidth = (WORD)256*RXBuffer[2] + RXBuffer[3];
     BitmapHeight = (WORD)256*RXBuffer[4] + RXBuffer[5];
    
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_BitmapBackStyle(WORD ID)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_BITMAPBACKSTYLE;
  RXCount = GET_BITMAPBACKSTYLE_RXNOB + 3;
  TXCount = GET_BITMAPBACKSTYLE_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (ID>>8)&0x00FF;
  TXBuffer[5] = (ID)&0x00FF;
  TXBuffer[6] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

     // Get Bitmap BackStyle
     BitmapBackStyle = RXBuffer[2];
   
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Set_Font(BYTE ID)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = SET_FONT;
  RXCount = 1;
  TXCount = SET_FONT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = ID;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Print(WORD CurX, WORD CurY, BYTE* pText)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = PRINT;
  RXCount = 1;
  TXCount = PRINT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  // First we need to know how many characters so we can set TXCount
  // and at the same time updating the TXBuffer

  for(i=0; i<256; i++)
   {
     TXBuffer[8+i] = *pText;
     if (*pText == 0)
      {
        TXCount = TXCount + i + 1;
        break;
      }
     pText++;
   } 

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = (CurX>>8)&0x00FF;
  TXBuffer[5] = (CurX)&0x00FF;
  TXBuffer[6] = (CurY>>8)&0x00FF;
  TXBuffer[7] = (CurY)&0x00FF;
  TXBuffer[TXCount - 1] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TextWidth(BYTE* pText)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TEXTWIDTH;
  RXCount = GET_TEXTWIDTH_RXNOB + 3;
  TXCount = GET_TEXTWIDTH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  // First we need to know how many characters so we can set TXCount
  // and at the same time updating the TXBuffer

  for(i=0; i<256; i++)
   {
     TXBuffer[4+i] = *pText;
     if (*pText == 0)
      {
        TXCount = TXCount + i + 1;
        break;
      }
     pText++;
   } 

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  
  TXBuffer[TXCount - 1] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get TextWidth
  TextWidth = (WORD)256*RXBuffer[2] + RXBuffer[3];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TextHeight(BYTE* pText)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TEXTHEIGHT;
  RXCount = GET_TEXTHEIGHT_RXNOB + 3;
  TXCount = GET_TEXTHEIGHT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  // First we need to know how many characters so we can set TXCount
  // and at the same time updating the TXBuffer

  for(i=0; i<256; i++)
   {
     TXBuffer[4+i] = *pText;
     if (*pText == 0)
      {
        TXCount = TXCount + i + 1;
        break;
      }
     pText++;
   } 

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  
  TXBuffer[TXCount - 1] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Text Height
  TextHeight = (WORD)256*RXBuffer[2] + RXBuffer[3];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TextLength(BYTE* pText)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TEXTLENGTH;
  RXCount = GET_TEXTLENGTH_RXNOB + 3;
  TXCount = GET_TEXTLENGTH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  // First we need to know how many characters so we can set TXCount
  // and at the same time updating the TXBuffer

  for(i=0; i<256; i++)
   {
     TXBuffer[4+i] = *pText;
     if (*pText == 0)
      {
        TXCount = TXCount + i + 1;
        break;
      }
     pText++;
   } 

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  
  TXBuffer[TXCount - 1] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Text Length (Number of Characters)
  TextLength = (WORD)256*RXBuffer[2] + RXBuffer[3];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_TextLineCount(BYTE* pText)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_TEXTLINECOUNT;
  RXCount = GET_TEXTLINECOUNT_RXNOB + 3;
  TXCount = GET_TEXTLINECOUNT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  // First we need to know how many characters so we can set TXCount
  // and at the same time updating the TXBuffer

  for(i=0; i<256; i++)
   {
     TXBuffer[4+i] = *pText;
     if (*pText == 0)
      {
        TXCount = TXCount + i + 1;
        break;
      }
     pText++;
   } 

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  
  TXBuffer[TXCount - 1] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Text Line Count (Number of Characters)
  TextLineCount = (WORD)256*RXBuffer[2] + RXBuffer[3];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_FontHeight(BYTE ID)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FONTHEIGHT;
  RXCount = GET_FONTHEIGHT_RXNOB + 3;
  TXCount = GET_FONTHEIGHT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = ID;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Font Height
  FontHeight = RXBuffer[2];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
// Return the width of each character in the font
void TerCmd_Get_FontWidth(BYTE ID, BYTE* pBuffer)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FONTWIDTH;
  RXCount = GET_FONTWIDTH_RXNOB + 3;
  TXCount = GET_FONTWIDTH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = ID;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Save font character widths
  for (i=0; i<244; i++)
   {
     *pBuffer = RXBuffer[2 + i];
      pBuffer++;
    }
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_Font()
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FONT;
  RXCount = GET_FONT_RXNOB + 3;
  TXCount = GET_FONT_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Current Font ID
  CurrentFont = RXBuffer[2];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}

/****************************************************************************/
void TerCmd_Get_FontColorDepth(BYTE ID)
{
  WORD i;

  CmdInProgress = 1;                         // Set Command In Progress Flag

  CmdCode = GET_FONTCOLORDEPTH;
  RXCount = GET_FONTCOLORDEPTH_RXNOB + 3;
  TXCount = GET_FONTCOLORDEPTH_TXNOB + 4;

  CmdTimeOut = 5;                          // 1 Sec time out

  TXBuffer[0] = SEGE_DEVID;
  TXBuffer[1] = ((TXCount - 4)>>8)&0x00FF;
  TXBuffer[2] = (TXCount - 4)&0x00FF;
  TXBuffer[3] = CmdCode;
  TXBuffer[4] = ID;
  TXBuffer[5] = GetTXChecksum();
  
  // Wait for Sege to be Ready (wait for Ready line to be low)
  IsSegeReady();

  // Send Command
  Send_Command();

  // Wait for the response to be received
  IsRxDone();

  // Get Font Height
  FontColorDepth = RXBuffer[2];
         
  CmdInProgress = 0;                         // Clear Command In Progress Flag           
}