/*****************************************************************************
 * BitmapBox Window1 driver
 *****************************************************************************
 * FileName:        Win1_Bitmapbox.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Win1_BitmapBox.h"


/********************************************************************/
void Show_Win1_BitmapBox()
{
  ActWin1ID = WINDOW1_BITMAPBOX;
  
  // Load Form
  GuiCmd_Load_Form(ActWin1ID);

  BitmapBox_Index = 0;
  BitmapBox_Enable = 0;

  // Show Form
  GuiCmd_Draw_Form(ActWin1ID);
}

/*******************************************************************/
void ui_Win1_BitmapBox()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_BITMAPBOX_BUTTON_OK:
      // Hide Window
      GuiCmd_View_Form(WINDOW1_BITMAPBOX, 0);
      // Enable BitmapBox Selection
      BitmapBox_Enable = 1;
      break;
   }
  }

 if (UI_Msg.Code == IMAGE_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_BITMAPBOX_IMAGE_BITMAPS:
      // Update Selected Bitmap Index
      BitmapBox_Index = UI_Msg.Value;
      break;
   }
  }

} 

     


