/*****************************************************************************
 * ColorBox Window1 driver
 *****************************************************************************
 * FileName:        Win1_ColorBox.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Win1_ColorBox.h"


/********************************************************************/
void Show_Win1_ColorBox()
{
  ActWin1ID = WINDOW1_COLORBOX;
  
  // Load Form
  GuiCmd_Load_Form(ActWin1ID);
  
  ColorBox_Enable = 0;
  ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_BLACK;
  ColorBox_Index_Old = WINDOW1_COLORBOX_SHAPE_BLACK;
  ColorBox_Color = BLACK;

  // Enable Border for Black
  GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, WINDOW1_COLORBOX_SHAPE_BLACK, SHAPE_PRO_BORDERSTYLE, REDRAW_NO, 1);
  
  // Show Form
  GuiCmd_Draw_Form(ActWin1ID);
}

/*******************************************************************/
void ui_Win1_ColorBox()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_COLORBOX_BUTTON_OK :
      // Hide Window
      GuiCmd_View_Form(WINDOW1_COLORBOX, 0);
      // Enable ColorBox Selection
      ColorBox_Enable = 1;
      break;
   }
  }

 if (UI_Msg.Code == SHAPE_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_COLORBOX_SHAPE_BLACK:
      // Update Selected Color
      ColorBox_Color = BLACK;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_BLACK;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_RED:
      // Update Selected Color
      ColorBox_Color = RED;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_RED;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_GREEN:
      // Update Selected Color
      ColorBox_Color = GREEN;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_GREEN;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_YELLOW:
      // Update Selected Color
      ColorBox_Color = YELLOW;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_YELLOW;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_BLUE:
      // Update Selected Color
      ColorBox_Color = BLUE;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_BLUE;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_MAGENTA:
      // Update Selected Color
      ColorBox_Color = MAGENTA;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_MAGENTA;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_CYAN:
      // Update Selected Color
      ColorBox_Color = CYAN;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_CYAN;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_COLORBOX_SHAPE_WHITE:
      // Update Selected Color
      ColorBox_Color = WHITE;
      // Update New Index
      ColorBox_Index_New = WINDOW1_COLORBOX_SHAPE_WHITE;
      // Update Shape Border
      if (ColorBox_Index_New != ColorBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ColorBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;
   }
  ColorBox_Index_Old = ColorBox_Index_New;
  }

} 

     


