/*****************************************************************************
 * FontBox Window1 driver
 *****************************************************************************
 * FileName:        Win1_Fontbox.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Win1_FontBox.h"


/********************************************************************/
void Show_Win1_FontBox()
{
  ActWin1ID = WINDOW1_FONTBOX;
  
  // Load Form
  GuiCmd_Load_Form(ActWin1ID);

  FontBox_Enable = 0;
  FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT0;
  FontBox_Index_Old = WINDOW1_FONTBOX_TEXTBOX_FONT0;
  FontBox_Font = 0;

  // Highlight Font0
  GuiCmd_TextBox_State(WINDOW1_FONTBOX_TEXTBOX_FONT0, 1);

  // Update Font Info
  Update_Font();

  // Show Form
  GuiCmd_Draw_Form(ActWin1ID);
}

/*******************************************************************/
void ui_Win1_FontBox()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_FONTBOX_BUTTON_OK:
      // Hide Window
      GuiCmd_View_Form(WINDOW1_FONTBOX, 0);
      // Update KeyBoard PictureBox Font
      GuiCmd_Set_ObjProperty_Byte(PICTUREBOX_CODE, SCREEN_KEYBOARD_PICTUREBOX_TEXT, PICTUREBOX_PRO_FONT,0 , FontBox_Font);
      break;
   }
  }

 if (UI_Msg.Code == TEXTBOX_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_FONTBOX_TEXTBOX_FONT0:
      FontBox_Font = 0;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT0;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT1:
      FontBox_Font = 1;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT1;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT2:
      FontBox_Font = 2;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT2;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT3:
      FontBox_Font = 3;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT3;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT4:
      FontBox_Font = 4;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT4;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT5:
      FontBox_Font = 5;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT5;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT6:
      FontBox_Font = 6;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT6;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;

      case WINDOW1_FONTBOX_TEXTBOX_FONT7:
      FontBox_Font = 7;
      FontBox_Index_New = WINDOW1_FONTBOX_TEXTBOX_FONT7;
      if (FontBox_Index_New != FontBox_Index_Old)
       {
        GuiCmd_TextBox_State(FontBox_Index_Old, 0);
        GuiCmd_TextBox_State(FontBox_Index_New, 1);
        Update_Font();
       }
      break;
   }
  FontBox_Index_Old = FontBox_Index_New;
  }
}

/*******************************************************************/
void Update_Font()
{
  // Get Font Height
  TerCmd_Get_FontHeight(FontBox_Font);
  // Get Font Characters widths
  TerCmd_Get_FontWidth(FontBox_Font, CharWidth);
  // Get Font ColorDepth
  TerCmd_Get_FontColorDepth(FontBox_Font);
  // Update Font Info
  GuiCmd_TextBox_Number(WINDOW1_FONTBOX_TEXTBOX_FONTID,1,0, FontBox_Font);
  GuiCmd_TextBox_Number(WINDOW1_FONTBOX_TEXTBOX_COLORDEPTH,1,0, FontColorDepth);
  GuiCmd_TextBox_Number(WINDOW1_FONTBOX_TEXTBOX_HEIGHT,1,0, FontHeight);
  GuiCmd_Set_ObjProperty_Byte(TEXTBOX_CODE, WINDOW1_FONTBOX_TEXTBOX_SAMPLE, TEXTBOX_PRO_FONT,0 , FontBox_Font);

  switch (FontBox_Font)
   {
    case 0:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"Arial");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 1:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"Arial");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 2:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"Arial");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 3:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"Arial");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 4:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"Arial");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Normal");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 5:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"ArialNarrow");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold Italic");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;
    
    case 6:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"ArialNarrow");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Normal");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;

    case 7:
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_NAME, (char*)"SansSerif");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_STYLE, (char*)"Bold");
    GuiCmd_TextBox_Text(WINDOW1_FONTBOX_TEXTBOX_SAMPLE, (char*)"Haidar Technology");
    break;
  }
}

     


