/*****************************************************************************
 * ShapeBox Window1 driver
 *****************************************************************************
 * FileName:        Win1_Shapebox.c
 * Dependencies:    see below
 * Processor:       PIC32
 * Compiler:       	MPLAB C32
 * Linker:          MPLAB LINK32
 * Company:         Haidar Technology, LLC.
 *
 * Software License Agreement
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *****************************************************************************/
#include "MainDemo.h"
#include "GUICommands.h"
#include "TerCommands.h"
#include "Demo_VGA_CA32.h"
#include "UiHandler.h"
#include "GUI.h"

#include "Win1_ShapeBox.h"


/********************************************************************/
void Show_Win1_ShapeBox()
{
  ActWin1ID = WINDOW1_SHAPEBOX;
  
  // Load Form
  GuiCmd_Load_Form(ActWin1ID);

  ShapeBox_Enable = 0;
  ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_SQUARE;
  ShapeBox_Index_Old = WINDOW1_SHAPEBOX_SHAPE_SQUARE;
  ShapeBox_Shape = SHAPEBOX_SQUARE;

  // Enable Border for Black
  GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, WINDOW1_SHAPEBOX_SHAPE_SQUARE, SHAPE_PRO_BORDERSTYLE, REDRAW_NO, 1);

  // Show Form
  GuiCmd_Draw_Form(ActWin1ID);
}

/*******************************************************************/
void ui_Win1_ShapeBox()
{
 if (UI_Msg.Code == BUTTON_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_SHAPEBOX_BUTTON_OK :
      // Hide Window
      GuiCmd_View_Form(WINDOW1_SHAPEBOX, 0);
      // Enable ShapeBox Selection
      ShapeBox_Enable = 1;
      break;
   }
  }

 if (UI_Msg.Code == SHAPE_CODE)
  {
   switch (UI_Msg.ID)
   {
      case WINDOW1_SHAPEBOX_SHAPE_SQUARE:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_SQUARE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_SQUARE;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_RECTANGLE:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_RECTANGLE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_RECTANGLE;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_BEVEL:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_BEVEL ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_BEVEL;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_CIRCLE:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_CIRCLE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_CIRCLE;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_SQUAREFILLED:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_FILLEDSQUARE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_SQUAREFILLED;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_RECTANGLEFILLED:
     // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_FILLEDRECTANGLE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_RECTANGLEFILLED;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_BEVELFILLED:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_FILLEDBEVEL ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_BEVELFILLED;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;

      case WINDOW1_SHAPEBOX_SHAPE_CIRCLEFILLED:
      // Update Selected Shape
      ShapeBox_Shape = SHAPEBOX_FILLEDCIRCLE ;
      // Update New Index
      ShapeBox_Index_New = WINDOW1_SHAPEBOX_SHAPE_CIRCLEFILLED;
      // Update Shape Border
      if (ShapeBox_Index_New != ShapeBox_Index_Old)
       {
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_New, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 1);
         GuiCmd_Set_ObjProperty_Byte(SHAPE_CODE, ShapeBox_Index_Old, SHAPE_PRO_BORDERSTYLE, REDRAW_YES, 0);
       }
      break;
   }
  ShapeBox_Index_Old = ShapeBox_Index_New;
  }

}   


